
	section	.data
	align	1
_rowpos
	dc.w	0
	dc.w	64
	dc.w	20
	dc.w	84

	section	.text
	align	1

	global	_lcd_chr
_lcd_chr
	pshm	z
	ais	#-2
	tsz

	ted	
	stab	0,z
	lde	_col
	aie	#1
	ste	_col
	cpe	_linekink
	bne	L2
	
	lde	#192
	jsr	_lcd_cmd

L2	ldab	0,z
	clra	
	tdy	
	xgdy	
	addd	#_xlat
	xgdy	
	ldab	0,y
	clra	
	tde	
	jsr	_lcd_data

	ais	#+2
	pulm	z
	rts

	align	1

	global	_lcd_chr_pretty
_lcd_chr_pretty
	pshm	z
	tsz

	tey	
	tyd	
	lde	#165
	cmpb	#31
	bls	L4
	
	clra	
	tde	

L4	jsr	_lcd_chr
	pulm	z
	rts

	align	1

	global	_lcd_str
_lcd_str
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	bra	L11
	

L9	ldy	0,z
	ldab	0,y
	clra	
	incw	0,z
	tde	
	jsr	_lcd_chr

L11	ldy	0,z
	tst	0,y
	bne	L9
	

	ais	#+2
	pulm	z
	rts

	align	1

	global	_lcd_buf
_lcd_buf
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	bra	L17
	

L15	ldy	0,z
	ldab	0,y
	clra	
	incw	0,z
	tde	
	jsr	_lcd_chr

L17	lde	2,z
	decw	2,z
	tste	
	bne	L15
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_lcd_buf_pretty
_lcd_buf_pretty
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	bra	L23
	

L21	ldy	0,z
	ldab	0,y
	clra	
	incw	0,z
	tde	
	jsr	_lcd_chr_pretty

L23	lde	2,z
	decw	2,z
	tste	
	bne	L21
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_lcd_row
_lcd_row
	pshm	z
	tsz

	cpe	_nrows
	bls	L25
	
	lde	_nrows

L25	aie	#-1
	ste	_row
	clrw	_col
	asle	
	tey	
	xgdy	
	addd	#_rowpos
	xgdy	
	lde	0,y
	ore	#128
	jsr	_lcd_cmd
	ldd	_ncols
	pulm	z
	rts

	align	1

	global	_lcd_row_space
_lcd_row_space
	pshm	z
	tsz

	lde	_col
	cpe	_ncols
	blo	L27
	
	clrd	
	bra	L28
	

L27	lde	_ncols
	ted	
	subd	_col

L28	pulm	z
	rts

	align	1

	global	_lcd_finis
_lcd_finis
	pshm	z
	tsz

	bra	L34
	

L32	lde	#32
	jsr	_lcd_chr

L34	lde	_col
	cpe	_ncols
	blo	L32
	
	pulm	z
	rts


	section	.data
_cg_check
	dc.b	1
	dc.b	10
	dc.b	4
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
_cg_padlock
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	6
	dc.b	9
	dc.b	15
	dc.b	15
_cg_flag
	dc.b	0
	dc.b	8
	dc.b	12
	dc.b	14
	dc.b	15
	dc.b	11
	dc.b	9
	dc.b	8
_cg_ake
	dc.b	4
	dc.b	0
	dc.b	14
	dc.b	1
	dc.b	15
	dc.b	17
	dc.b	15
	dc.b	0

	section	.text
	align	1
_chargen
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	asle	
	asle	
	asle	
	aie	#64
	jsr	_lcd_cmd
	clrw	0,z

L39	ldy	2,z
	ldab	0,y
	clra	
	incw	2,z
	tde	
	jsr	_lcd_data
	incw	0,z
	ldy	0,z
	cpy	#7
	bls	L39
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_lcd_rssi
_lcd_rssi
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	ldx	#50
	ldd	0,z
	idiv	
	stx	0,z
	cpx	#8
	bls	L42
	
	ldd	#8
	std	0,z

L42	lde	_prevssi
	cpe	0,z
	beq	L41
	
	bhs	L44
	
	ldy	#120
	tye	
	sube	0,z
	jsr	_lcd_cmd

L45	lde	#255
	jsr	_lcd_data
	lde	_prevssi
	aie	#1
	ste	_prevssi
	cpe	0,z
	blo	L45
	
	bra	L41
	

L44	lde	#120
	sube	_prevssi
	jsr	_lcd_cmd

L50	clre	
	jsr	_lcd_data
	lde	_prevssi
	aie	#-1
	ste	_prevssi
	cpe	0,z
	bhi	L50
	

L41
	ais	#+2
	pulm	z
	rts

	align	1
_char_gen_preset
	pshm	z
	tsz

	lde	#3
	ldd	#_cg_check
	jsr	_chargen
	lde	#4
	ldd	#_cg_padlock
	jsr	_chargen
	lde	#5
	ldd	#_cg_flag
	jsr	_chargen
	lde	#6
	ldd	#_cg_zero
	jsr	_chargen
	clrw	_prevssi
	lde	#7
	ldd	#_cg_ake
	jsr	_chargen
	clre	

L58	tey	
	xgdy	
	addd	#_xlat
	xgdy	
	ted	
	stab	0,y
	aie	#1
	cpe	#255
	bls	L58
	
	ldab	#7
	stab	_xlat+229
	stab	_xlat+197
	ldab	#225
	stab	_xlat+228
	stab	_xlat+196
	ldab	#239
	stab	_xlat+246
	stab	_xlat+214
	ldab	#245
	stab	_xlat+252
	stab	_xlat+220
	ldab	#223
	stab	_xlat+176
	ldab	#164
	stab	_xlat+92
	ldab	#235
	stab	_xlat+126
	ldab	#7
	stab	_xlat+140
	stab	_xlat+143
	stab	_xlat+134
	stab	_xlat+129
	ldab	#225
	stab	_xlat+132
	stab	_xlat+142
	stab	_xlat+138
	stab	_xlat+128
	ldab	#239
	stab	_xlat+148
	stab	_xlat+153
	stab	_xlat+154
	stab	_xlat+133
	pulm	z
	rts

	align	1

	global	_lcd_init
_lcd_init
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	jsr	_atoi
	std	_nrows
	lde	0,z
	aie	#2
	jsr	_atoi
	std	_ncols
	clrw	_col
	clrw	_row
	lde	_nrows
	clry	
	cpe	#1
	bne	L61
	
	cpd	#16
	bne	L61
	
	ldy	#9

L61	sty	_linekink
	lde	#56
	jsr	_lcd_cmd8
	lde	#5
	jsr	_delay_ms
	lde	#56
	jsr	_lcd_cmd8
	lde	#5
	jsr	_delay_ms
	lde	#56
	jsr	_lcd_cmd8
	lde	#5
	jsr	_delay_ms
	lde	#40
	jsr	_lcd_cmd8
	lde	#5
	jsr	_delay_ms
	lde	_nrows
	cpe	#1
	bne	L65
	
	lde	_ncols
	cpe	#16
	bne	L63
	

L65	lde	#40
	bra	L64
	

L63	lde	#32

L64	jsr	_lcd_cmd
	lde	#8
	jsr	_lcd_cmd
	lde	#12
	jsr	_lcd_cmd
	lde	#6
	jsr	_lcd_cmd
	lde	#2
	jsr	_lcd_cmd
	lde	#5
	jsr	_delay_ms
	lde	#15
	jsr	_lcd_cmd
	lde	#12
	jsr	_lcd_cmd
	jsr	_char_gen_preset
	lde	#4
	jsr	_lcd_row
	lde	#_ident+10
	jsr	_lcd_str
	jsr	_lcd_finis

	ais	#+2
	pulm	z
	rts


	section	.bss
_row
	ds.b	2
_col
	ds.b	2
_nrows
	ds.b	2
_ncols
	ds.b	2
_linekink
	ds.b	2
_xlat
	ds.b	256
_cg_zero
	ds.b	8
_prevssi
	ds.b	2


	end
