
#define     _DEG_AS_mm (60000u)        /*   1 degree, 60 minutes */
#define  _90_DEG_AS_mm (60000Lu *  90) /*  90 degrees */
#define _180_DEG_AS_mm (60000Lu * 180) /* 180 degrees */

struct vector {
	long lat, lon;          /* north/east positive */
	word course, knots;
};

#define negative_hemisphere(dw) (*(byte *) &(dw) & 0x80)

struct wallclock {
	byte
		year, month, day,
		hour, minute, second;
};

extern struct wallclock wallclock;

void wallclock_reset(void); /* call before presetting wallclock */
void wallclock_run(void);   /* second accumulation overflows ~ twice a day */

